// Code generated by informer-gen. DO NOT EDIT.

package v1

import (
	time "time"

	meteringv1 "github.com/kube-reporting/metering-operator/pkg/apis/metering/v1"
	versioned "github.com/kube-reporting/metering-operator/pkg/generated/clientset/versioned"
	internalinterfaces "github.com/kube-reporting/metering-operator/pkg/generated/informers/externalversions/internalinterfaces"
	v1 "github.com/kube-reporting/metering-operator/pkg/generated/listers/metering/v1"
	metav1 "k8s.io/apimachinery/pkg/apis/meta/v1"
	runtime "k8s.io/apimachinery/pkg/runtime"
	watch "k8s.io/apimachinery/pkg/watch"
	cache "k8s.io/client-go/tools/cache"
)

// ReportInformer provides access to a shared informer and lister for
// Reports.
type ReportInformer interface {
	Informer() cache.SharedIndexInformer
	Lister() v1.ReportLister
}

type reportInformer struct {
	factory          internalinterfaces.SharedInformerFactory
	tweakListOptions internalinterfaces.TweakListOptionsFunc
	namespace        string
}

// NewReportInformer constructs a new informer for Report type.
// Always prefer using an informer factory to get a shared informer instead of getting an independent
// one. This reduces memory footprint and number of connections to the server.
func NewReportInformer(client versioned.Interface, namespace string, resyncPeriod time.Duration, indexers cache.Indexers) cache.SharedIndexInformer {
	return NewFilteredReportInformer(client, namespace, resyncPeriod, indexers, nil)
}

// NewFilteredReportInformer constructs a new informer for Report type.
// Always prefer using an informer factory to get a shared informer instead of getting an independent
// one. This reduces memory footprint and number of connections to the server.
func NewFilteredReportInformer(client versioned.Interface, namespace string, resyncPeriod time.Duration, indexers cache.Indexers, tweakListOptions internalinterfaces.TweakListOptionsFunc) cache.SharedIndexInformer {
	return cache.NewSharedIndexInformer(
		&cache.ListWatch{
			ListFunc: func(options metav1.ListOptions) (runtime.Object, error) {
				if tweakListOptions != nil {
					tweakListOptions(&options)
				}
				return client.MeteringV1().Reports(namespace).List(options)
			},
			WatchFunc: func(options metav1.ListOptions) (watch.Interface, error) {
				if tweakListOptions != nil {
					tweakListOptions(&options)
				}
				return client.MeteringV1().Reports(namespace).Watch(options)
			},
		},
		&meteringv1.Report{},
		resyncPeriod,
		indexers,
	)
}

func (f *reportInformer) defaultInformer(client versioned.Interface, resyncPeriod time.Duration) cache.SharedIndexInformer {
	return NewFilteredReportInformer(client, f.namespace, resyncPeriod, cache.Indexers{cache.NamespaceIndex: cache.MetaNamespaceIndexFunc}, f.tweakListOptions)
}

func (f *reportInformer) Informer() cache.SharedIndexInformer {
	return f.factory.InformerFor(&meteringv1.Report{}, f.defaultInformer)
}

func (f *reportInformer) Lister() v1.ReportLister {
	return v1.NewReportLister(f.Informer().GetIndexer())
}
